import { Callback, CallbackType, Definition, Events, CallbackOptions, CallbackHandler } from './awayback.model';
/**
 * @license
 * awayback
 * Released under MIT license
 * Copyright Luca Raúl Joos
 */
declare function awayback<D extends Definition>(): {
    events: Events<D>;
    emit: <E extends keyof D>(event: E, ...data: Parameters<D[E]>) => void;
    on: <E extends keyof D>(event: E, handler: CallbackHandler<D, E>, options?: CallbackOptions) => void;
    once: <E extends keyof D>(event: E, handler: CallbackHandler<D, E>, options?: CallbackOptions) => void;
    only: <E extends keyof D>(event: E, handler: CallbackHandler<D, E>, options?: CallbackOptions) => void;
    remove: <E extends keyof D>(event: E, handler: CallbackHandler<D, E>) => void;
};
export { CallbackType };
export type { Callback, Definition, Events, CallbackOptions, CallbackHandler };
export default awayback;
